import { j as e } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as ze, useState as q, useMemo as h, useEffect as ue, useRef as u, useCallback as Me } from "react";
import { isMobile as I } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as Te, Table as M, Skeleton as ke } from "antd";
import Le from "../../BitzDrawer/index.mjs";
import Ee from "../../BitzLoadMore/index.mjs";
import He from "../../BitzPagination/index.mjs";
import Pe from "../../BitzNoData/index.mjs";
import Fe, { TableContext as Oe } from "../Store/index.mjs";
import Ve from "../TableSkeleton/index.mjs";
import { columnSort as _e, genColumnKey as J } from "../Store/utils/index.mjs";
import T from "../../../node_modules/ahooks/es/useSize/index.mjs";
import "./index.less.mjs";
import De from "../../../node_modules/lodash-es/at.mjs";
const Ke = ({
  tableItemEmit: j = () => {
  },
  showPagination: Q = !0,
  fillEvenRow: k = !0,
  evenRowBgColor: L = "#f9f9f9",
  outerHeight: x,
  outerMaxHeightRate: E = 0.4,
  heightRate: H = 0.6,
  dataSource: n = [],
  total: y = 0,
  columns: f,
  loading: g = !1,
  skeletonNum: W = 2,
  skeletonRender: P,
  skeletonRowNum: Y = 4,
  skeletonRowsWidth: Z = ["35%", "100%", "100%", "60%"],
  tableOperationEmit: R = () => {
  },
  mobileLoadEmit: S = () => {
  },
  mobileRefreshEmit: ee = () => {
  },
  operations: ne = [],
  enableControlPage: se,
  pagination: le,
  paginationEmit: ie = () => {
  },
  mobilePageHeight: re = 500,
  mobileCancelText: te = "取消",
  noDataTitle: oe,
  noDataImg: ae,
  color: he,
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  size: F,
  showTableTool: xe = !0,
  tableAction: fe,
  tableToolbar: ce,
  selectionBar: be,
  scroll: t,
  resetPage: ge,
  ...c
}) => {
  Te.useToken();
  const a = ze(Oe), [me, v] = q(!1), [pe, de] = q({}), je = h(() => (n == null ? void 0 : n.length) == y && (n == null ? void 0 : n.length) > 0, [n, y]), Ne = (s) => {
    v(!0), de(s), j(s);
  }, O = () => {
    v(!1);
  }, we = (s) => {
    v(!1), R(s.type, pe);
  }, m = h(() => {
    const s = (r) => r.map((i) => {
      const p = J((i == null ? void 0 : i.key) || (i == null ? void 0 : i.dataIndex), i.index), d = a.columnsMap[p];
      return d && d.show === !1 ? !1 : i.children ? {
        ...i,
        children: s(i.children)
      } : i;
    }).filter(Boolean), l = s(f);
    return [
      M.SELECTION_COLUMN,
      M.EXPAND_COLUMN,
      ...l.sort(_e(a.columnsMap))
    ];
  }, [a.columnsMap, f]);
  ue(() => {
    if (f && f.length > 0) {
      const s = f.map((l) => (
        // @ts-ignore
        J((l == null ? void 0 : l.key) ?? (l == null ? void 0 : l.dataIndex), l == null ? void 0 : l.dataIndex)
      ));
      a.setSortKeyColumns(s);
    }
  }, [f]);
  const N = u(null), C = T(N), V = u(null), o = T(V), { tableBlockHeight: w, y: B, paginationHeight: _, containerGap: D } = h(() => {
    if (typeof x > "u")
      return {};
    const s = window.innerHeight, l = x > s * E;
    let r = s - x;
    l && (r = s * H);
    let i = 40, p = 20, d = 40;
    if (N.current) {
      const z = window.getComputedStyle(N.current);
      i = parseInt(z.getPropertyValue("--cell-block") || "40");
      const Be = parseInt(z.getPropertyValue("--container-gap") || "20");
      p = n.length ? Be : 0, d = parseInt(z.getPropertyValue("--toolbar-height") || "40");
    }
    const ve = o == null ? void 0 : o.height, Ce = r - d - i - p - ((o == null ? void 0 : o.height) || 0);
    return { tableBlockHeight: r, y: Ce, paginationHeight: ve, containerGap: p };
  }, [
    x,
    E,
    H,
    n,
    o == null ? void 0 : o.height,
    C == null ? void 0 : C.height
  ]), K = u(null), b = T(K), A = h(() => {
    const s = ((b == null ? void 0 : b.height) || 0) + (D || 0) + (_ || 0);
    return (w || 0) > s;
  }, [
    b == null ? void 0 : b.height,
    w,
    _,
    D
  ]), ye = h(() => A ? window.innerHeight - (x || 0) : w, [x, A, w]), $ = h(() => t != null && t.x ? { x: t.x, y: t.y || B } : t != null && t.y ? n != null && n.length ? { x: 1e3, y: t.y } : { x: 1e3 } : n != null && n.length ? { x: 1e3, y: B } : { x: 1e3 }, [n, t, B]), G = h(() => `${F ?? (a == null ? void 0 : a.tableSize) ?? "lg"}BitzTable`, [F, a.tableSize]), U = h(() => ({
    "--evenRow-BgColor": L
    // '--tableBody-bootomBorderColor': token.Table?.borderColor || '#f0f0f0',
  }), [
    L
    /** token.Table?.borderColor */
  ]), X = Me((s, l) => k ? l % 2 === 0 ? "oddRow" : "evenRow" : "", [k]);
  return e.jsxs("div", { className: "bitzTableBlock", children: [!I && e.jsxs("div", { ref: N, className: `bitzTableContainer ${G}`, style: { height: ye }, children: [e.jsxs("div", { className: "bitzTableContainerBody", ref: K, children: [xe && e.jsxs("div", { className: "bitzTableToolbarBlock", children: [fe || e.jsx("div", {}), ce, (c == null ? void 0 : c.rowSelection) && e.jsx(e.Fragment, { children: be })] }), g ? e.jsx(Ve, { columns: m, dataLength: n == null ? void 0 : n.length, scroll: $, rowSelection: c.rowSelection, expandable: c.expandable, className: G, style: U, rowClassName: X }) : e.jsx(M, { columns: m, dataSource: n, loading: g, pagination: !1, scroll: $, ...c, style: U, rowClassName: X })] }), Q && e.jsx(He, { ref: V, enableControl: se, pagination: le, total: y, dataSource: n, resetPage: ge, paginationEmit: ie })] }), I && e.jsxs(e.Fragment, { children: [(g || (n == null ? void 0 : n.length) > 0) && e.jsx(Ee, { color: he, height: re, showNoMore: je, refreshEmit: ee, loadEmit: S, extra: e.jsxs("div", { className: "mobileTable", children: [n == null ? void 0 : n.map((s, l) => e.jsxs("div", { children: [e.jsx("div", { className: "rowBox", children: m == null ? void 0 : m.map((r, i) => e.jsx("div", { children: !(r != null && r.mobileHide) && e.jsxs("div", { className: "row", onClick: () => {
    Ne(s);
  }, children: [e.jsxs("div", { className: "label", children: [r.title, "："] }), e.jsx("div", { className: "value", children: r.render(De(s, r == null ? void 0 : r.dataIndex), s, l) })] }) }, i)) }), e.jsx("div", { className: "rowBoxLine" })] }, l)), g && Array.from({ length: W }).map((s, l) => e.jsxs("div", { children: [e.jsx("div", { className: "rowBox", children: P ? P() : e.jsx(ke, { title: !1, paragraph: {
    rows: Y,
    width: Z
  }, active: !0 }) }), e.jsx("div", { className: "rowBoxLine" })] }, l)), e.jsx(Le, { className: "tableMobileDrawer", open: me, placement: "bottom", height: "auto", closable: !1, onClose: O, children: e.jsxs("div", { className: "drawerBox", children: [e.jsx("div", { className: "boxBody", children: ne.map((s, l) => e.jsx("div", { className: "operaList", onClick: () => {
    we(s);
  }, children: s.label }, l)) }), e.jsx("div", { className: "boxLine" }), e.jsx("div", { className: "boxFooter", onClick: O, children: te })] }) })] }) }), !g && e.jsx(Pe, { data: n, title: oe, img: ae })] })] });
}, en = (j) => (
  // @ts-ignore
  e.jsx(Fe, { initValue: j, children: e.jsx(Ke, { ...j }) })
);
export {
  en as default
};
